/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include "DOMNameHash.hpp"

unsigned long hashNameNS(const XMLCh *namespaceURI, const XMLCh *name)
{
  const XMLCh openCurly = 0x7B;
  const XMLCh closeCurly = 0x7D;
  const XMLCh* rawNamespaceBuf = namespaceURI;
  const XMLCh* rawNameBuf = name;
  unsigned long hashValue = 0L;

  if ((rawNamespaceBuf != 0) || (rawNameBuf != 0)) {
    hashValue = 5 * hashValue + openCurly;
    for (unsigned int i = 0; i < XERCES_CPP_NAMESPACE_QUALIFIER XMLString::stringLen(namespaceURI); i++) {
      hashValue = 5 * hashValue + rawNamespaceBuf[i];
    }
    hashValue = 5 * hashValue + closeCurly;
    for (unsigned int j = 0; j < XERCES_CPP_NAMESPACE_QUALIFIER XMLString::stringLen(name); j++) {
      hashValue = 5 * hashValue + rawNameBuf[j];
    }
  }

  return hashValue++;
}
