/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef _DOMXMLCHBUILDER_HPP
#define _DOMXMLCHBUILDER_HPP

#include <config.h>

#include <vector>

#include <xercesc/util/XMLString.hpp>

class PATHAN_EXPORT XMLChBuilder {
public:

   XMLChBuilder();
   ~XMLChBuilder();

   // Append an XMLCh string
   void append(const XMLCh* string);

   // Append an XMLCh string and delete it afterwards
   void appendAndDelete(const XMLCh* string);

   // Append a character literal. NB. This is much less efficient than
   // creating an XMLCh literal and passing to append
   void appendLiteral(const char* string);

   // Caller takes ownership
   XMLCh* fetch();

private:

   typedef std::vector<const XMLCh*> StringVector;

   StringVector fragments;
   StringVector ownedBlocks;
};

#endif // _DOMXMLCHBUILDER_HPP
