/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include "DataItem.hpp"
#include "../DOMutils/v2Utils.hpp"
#include "../defs/NumUtils.hpp"
#include "DataItem.hpp"

/**
 * Warning: this is not a copy constructor: Martin please explain
 * use here.
 */
DataItem::DataItem(const DataItem& rhs)
   :
#ifdef TEST
     TestCase("DataItem"),
#endif
     _type(rhs._type)
{
}

DataItem::~DataItem(void)
{
  //no-op
}

DataItem& DataItem::operator= (const DataItem& rhs) {
  if (&rhs != this) {
    _type = rhs._type;
  }
  return *this;
}

int DataItem::asInt(const Context *context) const
{
  XSFloat d = this->asNum(context);

  if(NumUtils::isNaN(d)) { //NaN
    /* Do we need to be careful here, as we loose
       the NaN value by converting to int? */
    return 0;
  } else if(d < 0) {
    d -= 0.5;
    return static_cast<int>(ceil(d));
  }
  else {
    d += 0.5;
    return static_cast<int>(floor(d));
  }
}

DataItem::whichType DataItem::getType(void) const
{
  return _type;
}

void DataItem::setType(DataItem::whichType t)
{
  _type = t;
}

DataItem::DataItem(void)
#ifdef TEST
  : TestCase("DataItem")
#endif
{
  // Nothing to do
}

#ifdef TEST
DataItem::DataItem( string name )
  : TestCase( name )
{
  // Nothing to do
}
#endif
