/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef _DATAITEMFUNCTION_HPP
#define _DATAITEMFUNCTION_HPP

#ifndef WIN32
#include <config.h>
#else
#pragma warning(disable : 4251)
#endif

#include "DataItem.hpp"
#include "DeadNodeList.hpp"
#include "DataItem.hpp"

class PATHAN_EXPORT DataItemFunction : public DataItem
{

public:
  DataItemFunction(const vector<const DataItem*> &args);
  virtual ~DataItemFunction();

  ///returns the evaluated Functions DataItem as a Bool
  bool asBool(const Context *context) const;
  ///returns the evaluated Functions DataItem as a String
  const XMLCh *asString(const Context *context) const;
  ///returns the evaluated Functions DataItem as a Num
  XSFloat asNum(const Context *context) const;
  ///returns the evaluated Functions DataItem as a NodeList
  DeadNodeList *asNodeList(const Context *context, const bool singleNode) const;

  DataItem *asSimpleDataItem(const Context *context) const;

  ///returns the evaluated Functions DataItem is equal to other
  bool isEqual(const DataItem *other, const Context *context) const;
  ///returns the evaluated Functions DataItem is less than other
  bool isLessThan(const DataItem *other, const Context *context) const;
  ///returns the evaluated Functions DataItem is greater than other
  bool isGreaterThan(const DataItem *other, const Context *context) const;

protected:
  ///evalutes the funtion based on the args and returns the resulting DataItem
  virtual DataItem *execute(const Context *context) const = 0;

#ifndef TEST
  const vector<const DataItem*> _args; // The real store for arguments
#else
  vector<const DataItem*> _args; // Not really here! Only for testing
#endif
  mutable const XMLCh *_lastString;
};

#endif
