/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef _DATAITEMVARIABLE_HPP
#define _DATAITEMVARIABLE_HPP

#include <config.h>

#include "DataItem.hpp"
#include "../simpleVariables/VariableStore.hpp"
class DataItem;

/** Deals with all the simple variable stuff.*/
class PATHAN_EXPORT DataItemVariable : public DataItem
{
public:
  DataItemVariable(const XMLCh *prefix, const XMLCh *name);
  ~DataItemVariable();

  ///returns the evaluated Variables DataItem as a Bool
  bool asBool(const Context *context) const;
  ///returns the evaluated Variables DataItem as a String
  const XMLCh *asString(const Context *context) const;
  ///returns the evaluated Variables DataItem as a Num
  XSFloat asNum(const Context *context) const;
  ///returns the evaluated Variables DataItem as a NodeList
  DeadNodeList *asNodeList(const Context *context, const bool singleNode) const;

  ///evalutes the variable, and returns the answer as a DataItem
  DataItem *asSimpleDataItem(const Context *context) const;

  ///returns the evaluated Variables DataItem is equal to other
  bool isEqual(const DataItem *other, const Context *context) const;
  ///returns the evaluated Variables DataItem is less than other
  bool isLessThan(const DataItem *other, const Context *context) const;
  ///returns the evaluated Variables DataItem is greater than other
  bool isGreaterThan(const DataItem *other, const Context *context) const;

private:
  ///evalutes the funtion based on the args and returns the resulting DataItem
  const DataItem *lookUpVariable(const Context *context) const;

  const XMLCh *_prefix;
  const XMLCh *_name;
};

#endif


