/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*

  Exception - super class for all exceptions

*/

#ifndef _DSLEXCEPTION_HPP
#define _DSLEXCEPTION_HPP

#include <config.h>


#include <string>
//using namespace std;

/** The exception super class. Please inherit from this class, and sub class as
    appropriate. This can be used as a method of catching groups of exceptions. */
class DSLException
{
public:
  ///constructor. Preferred type takes a description string
   DSLException(std::string e) : _error(e) {};
  ///constructor. For when you're in too much of a rush to pass a string.
  DSLException() : _error("Undefined error.") {};
  ///destructor
  virtual ~DSLException() {};

  /// get method.
  virtual const std::string getError() const {return _error;};

private:
  std::string _error;
};

#endif // _DSLEXCEPTION_HPP
