/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*
  Factory base class
*/

#ifndef _FUNCFACTORY_HPP
#define _FUNCFACTORY_HPP

#include <config.h>

#include<vector>
#include "../dataItem/DataItem.hpp"

class DataItem;

class PATHAN_EXPORT FuncFactory
{
public:
  FuncFactory();
  virtual ~FuncFactory();

  ///Create instance of a function, using FuncFactoryTemplate to determine type
  virtual DataItem *createInstance(const std::vector<const DataItem*> &args) = 0;
};

#endif
