/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*
  Factory template class
*/

#ifndef _FUNCFACTORYTEMPLATE_HPP
#define _FUNCFACTORYTEMPLATE_HPP

#include <config.h>


#include "FuncFactory.hpp"
#include "../dataItem/DataItem.hpp"
#include <vector>

///Macro used to facilitate the creation of functions
template<class TYPE> class FuncFactoryTemplate : public FuncFactory
{
public:
  FuncFactoryTemplate();
  DataItem *createInstance(const std::vector<const DataItem*> &args);
};

template<class TYPE> FuncFactoryTemplate<TYPE>::FuncFactoryTemplate()
{
  // Nothing to do
}

template<class TYPE> DataItem*
FuncFactoryTemplate<TYPE>::createInstance(const std::vector<const DataItem*> &args)
{
  return new TYPE(args);
}

#endif
