/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*

  Ceiling function

*/

#ifndef _FUNCTIONCEILING_HPP
#define _FUNCTIONCEILING_HPP

#include <config.h>


#include "XPathFunction.hpp"

/** Ceiling function. */
class PATHAN_EXPORT FunctionCeiling : public XPathFunction
{
public:
  FunctionCeiling(const vector<const DataItem*> &args);

  /** XPath function. returns number rounded up to an integer **/
  DataItem *execute(const Context *context) const;

#ifdef TEST
  ///Dummy constructor for test suite
  FunctionCeiling(std::string name);
  ///Test setup
  void setUp();
  ///Test count
  void testExecute();
#endif
};

#endif // _FUNCTIONCEILING_HPP


#if 0
<userDoc>
<section>
  <title><command>ceiling</command></title>

  <section>
  <title>Synopsis</title>
  <para>
  <synopsis>
  <emphasis>ceiling(argument1) -> number</emphasis>
  argument1 = number #PCDATA #REQUIRED
  </synopsis>
  </para>
  </section>

  <section>
    <title>Description</title>
    <para>The ceiling function returns the smallest (closest to negative infinity)
    number that is not less than the argument and that is an integer.
    </para>
  </section>
</section>
</userDoc>

#endif
