/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*

  Contains function

*/

#ifndef _FUNCTIONCONTAINS_HPP
#define _FUNCTIONCONTAINS_HPP

#include <config.h>


#include "XPathFunction.hpp"

/** Contains function. */
class PATHAN_EXPORT FunctionContains : public XPathFunction
{
public:
  FunctionContains(const vector<const DataItem*> &args);

  /** XPath function. returns true if string1 conatins string2 **/
  DataItem *execute(const Context *context) const;

#ifdef TEST
  ///Dummy constructor for test suite
  FunctionContains(std::string name);
  ///Test setup
  void setUp();
  ///Test count
  void testExecute();
#endif
};

#endif // _FUNCTIONCONTAINS_HPP


#if 0
<userDoc>
<section>
  <title><command>contains</command></title>

  <section>
  <title>Synopsis</title>
  <para>
  <synopsis>
  <emphasis>contains(argument1,argument2) -> string</emphasis>
  argument1 = string  #PCDATA #REQUIRED
  argument2 = string #PCDATA #REQUIRED
  </synopsis>
  </para>
  </section>

  <section>
    <title>Description</title>
    <para>The contains function returns true if the first argument string contains
    the second argument string, and otherwise returns false.
    </para>
  </section>
</section>
</userDoc>

#endif






