/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include "FunctionCount.hpp"
#include "../dataItem/DeadNodeList.hpp"
#include "../dataItem/DataItemNumeric.hpp"
#include <memory>

FunctionCount::FunctionCount(const vector<const DataItem*> &args)
  : XPathFunction(1, 1, args)
{
}

DataItem *FunctionCount::execute(const Context *context) const
{
  auto_ptr<DeadNodeList> list(getNodeListArg(0, context));
  return new DataItemNumeric(list->getLength());
}

#ifdef TEST

#include <xercesc/dom/DOMDocument.hpp>
#include "../testharness/TestFunction.hpp"

// Test functions

void FunctionCount::setUp()
{

  // Nothing to do

}

FunctionCount::FunctionCount(std::string name)
  : XPathFunction(2, 2, vector<const DataItem*>())
{




}

// Not tests
void FunctionCount::testExecute()
{

  // No testing, as this function is too simple.

}

#endif
