/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*

  Floor function

*/

#ifndef _FUNCTIONFLOOR_HPP
#define _FUNCTIONFLOOR_HPP

#include <config.h>


#include "XPathFunction.hpp"

/** Floor function. */
class PATHAN_EXPORT FunctionFloor : public XPathFunction
{
public:
  FunctionFloor(const vector<const DataItem*> &args);

  /** XPath function. returns number rounded down to an integer **/
  DataItem *execute(const Context *context) const;

#ifdef TEST
  ///Dummy constructor for test suite
  FunctionFloor(std::string name);
  ///Test setup
  void setUp();
  ///Test count
  void testExecute();
#endif
};

#endif // _FUNCTIONFLOOR_HPP


#if 0
<userDoc>
<section>
  <title><command>floor</command></title>

  <section>
  <title>Synopsis</title>
  <para>
  <synopsis>
  <emphasis>floor(argument1) -> number</emphasis>
  argument1 = number #PCDATA #REQUIRED
  </synopsis>
  </para>
  </section>

  <section>
    <title>Description</title>
    <para>The floor function returns the largest (closest to positive infinity)
    number that is not greater than the argument and that is an integer.
    </para>
  </section>
</section>
</userDoc>

#endif






