/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include "FunctionNot.hpp"
#include "../dataItem/DataItemBool.hpp"

FunctionNot::FunctionNot(const vector<const DataItem*> &args)
  : XPathFunction(1, 1, args)
{
}

DataItem *FunctionNot::execute(const Context *context) const
{
  return new DataItemBool(!getBoolArg(0, context));
}

#ifdef TEST

#include <xercesc/dom/DOMDocument.hpp>
#include "../testharness/TestFunction.hpp"

// Test functions

void FunctionNot::setUp()
{

  // Nothing to do

}

FunctionNot::FunctionNot(std::string name)
  : XPathFunction(2, 2, vector<const DataItem*>())
{




}

// Not testes
void FunctionNot::testExecute()
{

  // No testing, as this function is too simple.

}

//*********************
#endif
