/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*

  Not function

*/

#ifndef _FUNCTIONNOT_HPP
#define _FUNCTIONNOT_HPP

#include <config.h>


#include "XPathFunction.hpp"

/** Not operator function. */
class PATHAN_EXPORT FunctionNot : public XPathFunction
{
public:
  FunctionNot(const vector<const DataItem*> &args);

  /** negates the argument **/
  DataItem *execute(const Context *context) const;

#ifdef TEST
  ///Dummy constructor for test suite
  FunctionNot(std::string name);
  ///Test setup
  void setUp();
  ///Test boolean on a node
  void testExecute();
#endif
};

#endif // _FUNCTIONNOT_HPP


#if 0
<userDoc>
<section>
  <title><command>not</command></title>

  <section>
  <title>Synopsis</title>
  <para>
  <synopsis>
  <emphasis>not(argument1) -> boolean</emphasis>
  argument1 = boolean-expression #REQUIRED
  </synopsis>
  </para>
  </section>

  <section>
    <title>Description</title>
    <para>
    This function returns true if the argument is false, and false if the argument is true.
    </para>
  </section>

  <section>
    <title>Examples</title>
    <para>
    The program:
    <programlisting><![CDATA[
      <xst xmlns="http://www.xmlscript.org/2.0" expression-syntax="dslpath">

      <output>

      a 0 # not(1) #
      b 1 # not(0) #
      c 0 # not("string") #
      d 1 # not("") #
      e 0 # not(-1) #

      </output>
      </xst>
    ]]></programlisting>
    should produce the output
    <screen>
      a 0 0
      b 1 1
      c 0 0
      d 1 1
      e 0 0
    </screen>
    </para>
  </section>
</section>
</userDoc>

#endif






