/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*

  Number function

*/

#ifndef _FUNCTIONNUMBER_HPP
#define _FUNCTIONNUMBER_HPP

#include <config.h>


#include "XPathFunction.hpp"

/** Number operator function, and exists functions. */
class PATHAN_EXPORT FunctionNumber : public XPathFunction
{
public:
  FunctionNumber(const vector<const DataItem*> &args);

  /** Returns the argument as a number **/
  DataItem *execute(const Context *context) const;

#ifdef TEST
  ///Dummy constructor for test suite
  FunctionNumber(std::string name);
  ///Test setup
  void setUp();
  ///Test boolean on a node
  void testExecute();
#endif
};

#endif // _FUNCTIONNUMBER_HPP


#if 0
<userDoc>
<section>
  <title><command>number</command></title>

  <section>
  <title>Synopsis</title>
  <para>
  <synopsis>
  <emphasis>number(argument1) -> numeral</emphasis>
  argument1 = #PCDATA #REQUIRED
  </synopsis>
  </para>
  </section>

  <section>
    <title>Description</title>
    <para>
    This function returns the numerical conversion of the given argument. This command may be
    shortened to 'num' (see example below).
    </para>
  </section>

  <section>
    <title>Examples</title>
    <para>
    The program:
    <programlisting><![CDATA[
      <xst xmlns="http://www.xmlscript.org/2.0" xmlns:xs="http://www.xmlscript.org/2.0"
          expression-syntax="dslpath">

      <data>
        <bream>43bogs
        </bream>
      </data>

      <output>
      # number(\xs:dd\*:bream) #
      # num ("-123") #
      # number("carp") #
      </output>

      </xst>
    ]]></programlisting>
    should produce the output
    <screen>
      43
      -123
      0
    </screen>
    </para>
  </section>
</section>
</userDoc>

#endif






