/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include "FunctionOpDivide.hpp"
#include "../dataItem/DataItemNumeric.hpp"

FunctionOpDivide::FunctionOpDivide(const vector<const DataItem*> &args)
  : XPathFunction(2, 2, args)
{
  // Nothing to do
}

DataItem *FunctionOpDivide::execute(const Context *context) const
{
  return new DataItemNumeric(getNumeralArg(0, context) / getNumeralArg(1, context));
}

#ifdef TEST
// Test functions
#include "../dataItem/DataItemString.hpp"
#include "../dataItem/DataItemBool.hpp"
#include "../dataItem/DataItemNodeList.hpp"
#include "../testharness/TestFunction.hpp"

void FunctionOpDivide::setUp()
{

  // Nothing to do

}

FunctionOpDivide::FunctionOpDivide( std::string name)
  : XPathFunction(2, 2, vector<const DataItem*>())
{
}

void FunctionOpDivide::testExecute()
{
  Context c;
  Context *context = &c;

  auto_ptr<DataItemNumeric> num(new DataItemNumeric(4));
  DataItem *item1 = num.get();
  _args.push_back(item1);

  auto_ptr<DataItemNumeric> num2(new DataItemNumeric(2));
  DataItem *item2 = num2.get();
  _args.push_back(item2);

  auto_ptr<DataItem> result(execute(context));

  assert(result->asNum(context) == 2);

  _args.clear();
}

#endif
