/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include "FunctionOpMod.hpp"
#include "../exceptions/FunctionException.hpp"
#include "../dataItem/DataItemNumeric.hpp"

FunctionOpMod::FunctionOpMod(const vector<const DataItem*> &args)
  : XPathFunction(2, 2, args)
{
}

DataItem *FunctionOpMod::execute(const Context *context) const
{
  int r = getIntArg(0, context);
  int p = getIntArg(1, context);

  if(p == 0) {
    throw FunctionException("FunctionOpMod", "Invalid modulus of 0 given");
  } else {
    return new DataItemNumeric(XSFloat(r % p));
  }//if
}

#ifdef TEST
// Test functions
#include "../testharness/TestFunction.hpp"
#include "../dataItem/DataItemString.hpp"
#include "../dataItem/DataItemBool.hpp"
#include "../dataItem/DataItemNodeList.hpp"
void FunctionOpMod::setUp()
{

  // Nothing to do

}

FunctionOpMod::FunctionOpMod( std::string name)
   : XPathFunction(2, 2, vector<const DataItem*>())
{





}

// Not really properly tested here. As we use built in mod function.
void FunctionOpMod::testExecute()
{
  Context c;
  Context *context = &c;

  auto_ptr<DataItemNumeric> num(new DataItemNumeric(4));
  DataItem *item1 = num.get();
  _args.push_back(item1);

  auto_ptr<DataItemNumeric> num2(new DataItemNumeric(2));
  DataItem *item2 = num2.get();
  _args.push_back(item2);




  auto_ptr<DataItem> result(execute(context));

  assert(result->asNum(context) == 0);

  _args.clear();
}

#endif
