/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*

   OpPlus operator function

*/

#ifndef _FUNCTIONOPPLUS_HPP
#define _FUNCTIONOPPLUS_HPP

#include <config.h>

#include "XPathFunction.hpp"

/** OpPlus operator function*/
class PATHAN_EXPORT FunctionOpPlus : public XPathFunction
{
public:
  FunctionOpPlus(const vector<const DataItem*> &args);

  /** OpPlusenates two DataItems. Takes two DataItems and returns the sum of them*/
  DataItem *execute(const Context *context) const;

#ifdef TEST
  ///Dummy constructor for test suite
  FunctionOpPlus(std::string name);
  ///Test setup
  void setUp();
  ///Test function
  void testExecute();
#endif
};

#endif // _FUNCTIONOPPLUS_HPP

#if 0
<userDoc>
<section>
  <title><command>plus</command></title>

  <section>
  <title>Synopsis</title>
  <para>
  <synopsis>
  <emphasis>plus(argument1, argument2) -> numeral</emphasis>
  argument1 = #PCDATA #REQUIRED
  argument2 = #PCDATA #REQUIRED
  </synopsis>
  </para>
  </section>

  <section>
    <title>Description</title>
    <para>
    This function returns the summation of argument1 and argument2. This function may be represented
    by one of 'plus', or '+' (see example below).
    </para>
  </section>

  <section>
    <title>Examples</title>
    <para>
    The program:
    <programlisting><![CDATA[
      <xst xmlns="http://www.xmlscript.org/2.0" xmlns:xs="http://www.xmlscript.org/2.0"
           expression-syntax="dslpath">

      <output>
      a # plus("5","4") #
      b # sum("one","two") #
      c # sum(3,6) #
      d # 8 + 4 #
      </output>

      </xst>
    ]]></programlisting>
    should produce the output
    <screen>
      a 9
      b 0
      c 9
      d 12
    </screen>
    </para>
  </section>
</section>
</userDoc>

#endif






