/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*

   OpTimes operator function

*/

#ifndef _FUNCTIONOPTIMES_HPP
#define _FUNCTIONOPTIMES_HPP

#include <config.h>

#include "XPathFunction.hpp"

/** OpTimes operator function*/
class PATHAN_EXPORT FunctionOpTimes : public XPathFunction
{
public:
  FunctionOpTimes(const vector<const DataItem*> &args);

  /** OpTimesenates two DataItems. Takes two DataItems and returns the product of them*/
  DataItem *execute(const Context *context) const;

#ifdef TEST
  ///Dummy constructor for test suite
  FunctionOpTimes(std::string name);
  ///Test setup
  void setUp();
  ///Test function
  void testExecute();
#endif
};

#endif // _FUNCTIONOPPLUS_HPP

#if 0
<userDoc>
<section>
  <title><command>times</command></title>

  <section>
  <title>Synopsis</title>
  <para>
  <synopsis>
  <emphasis>times(argument1, argument2) -> numeral</emphasis>
  argument1 = #PCDATA #REQUIRED
  argument2 = #PCDATA #REQUIRED
  </synopsis>
  </para>
  </section>

  <section>
    <title>Description</title>
    <para>
    This function returns the product of argument1 and argument2. This function may also be
    represented by '*' (see example below).
    </para>
  </section>

  <section>
    <title>Examples</title>
    <para>
    The program:
    <programlisting><![CDATA[
      <xst xmlns="http://www.xmlscript.org/2.0" xmlns:xs="http://www.xmlscript.org/2.0"
           expression-syntax="dslpath">

      <output>
      a # times("5","4") #
      b # times("one","two") #
      c # 0 * 3 #
      d # 84 * 0 #
      </output>

      </xst>
    ]]></programlisting>
    should produce the output
    <screen>
      a 20
      b 0
      c 0
      d 0
    </screen>
    </para>
  </section>
</section>
</userDoc>

#endif







