/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*

  Round function

*/

#ifndef _FUNCTIONROUND_HPP
#define _FUNCTIONROUND_HPP

#include <config.h>


#include "XPathFunction.hpp"

/** Round function. */
class PATHAN_EXPORT FunctionRound : public XPathFunction
{
public:
  FunctionRound(const vector<const DataItem*> &args);

  /** XPath function. returns number rounded down to an integer **/
  DataItem *execute(const Context *context) const;

#ifdef TEST
  ///Dummy constructor for test suite
  FunctionRound(std::string name);
  ///Test setup
  void setUp();
  ///Test count
  void testExecute();
#endif
};

#endif // _FUNCTIONROUND_HPP


#if 0
<userDoc>
<section>
  <title><command>round</command></title>

  <section>
  <title>Synopsis</title>
  <para>
  <synopsis>
  <emphasis>round(argument1) -> number</emphasis>
  argument1 = number #PCDATA #REQUIRED
  </synopsis>
  </para>
  </section>

  <section>
    <title>Description</title>
    <para>The round function returns the number that is closest to the argument and
    that is an integer.  If there are two such numbers, then the one that is closest
    to positive infinity is returned.  If the argument is NaN, then NaN is returned.
    If the argument is positive infinity, then positive infinity is returned.  If the
    argument is negative infinity, then negative infinity is returned.  If the argument
    is positive zero, then positive zero is returned.  If the argument is negative
    zero, then negative zero is returned.  If the argument is less than zero, but
    greater than or equal to -0.5, then negative zero is returned.</para>
    <para>NOTE: For these last two cases, the result of calling the round function is
    not the same as the result of adding 0.5 and then calling the floor function.
    </para>
  </section>
</section>
</userDoc>

#endif






