/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*

  StartsWith function

*/

#ifndef _FUNCTIONSTARTSWITH_HPP
#define _FUNCTIONSTARTSWITH_HPP


#include "XPathFunction.hpp"

/** StartsWith function. */
class PATHAN_EXPORT FunctionStartsWith : public XPathFunction
{
public:
  FunctionStartsWith(const vector<const DataItem*> &args);

  /** XPath function. returns true if string1 starts with string2 **/
  DataItem *execute(const Context *context) const;

#ifdef TEST
  ///Dummy constructor for test suite
  FunctionStartsWith(std::string name);
  ///Test setup
  void setUp();
  ///Test count
  void testExecute();
#endif
};

#endif // _FUNCTIONSTARTSWITH_HPP


#if 0
<userDoc>
<section>
  <title><command>starts-with</command></title>

  <section>
  <title>Synopsis</title>
  <para>
  <synopsis>
  <emphasis>starts-with(argument1,argument2) -> bool</emphasis>
  argument1 = string  #PCDATA #REQUIRED
  argument2 = string #PCDATA #REQUIRED
  </synopsis>
  </para>
  </section>

  <section>
    <title>Description</title>
    <para>The starts-with function returns true if the first argument string starts with
    the second argument string, and otherwise returns false.
    </para>
  </section>
</section>
</userDoc>

#endif






