/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include "FunctionString.hpp"

#include "../DOMutils/v2Utils.hpp"
#include "../context/Context.hpp"
#include "../dataItem/DataItemString.hpp"

FunctionString::FunctionString(const vector<const DataItem*> &args)
  : XPathFunction(0, 1, args)
{
}

DataItem *FunctionString::execute(const Context *context) const
{
  const XMLCh *result = NULL;

  if(getNumArgs() == 1) {
    result = getStringArg(0, context);
  } else {
    result = v2Utils::getStringFromNode(context->getCurrentContext());
  }
  
  return new DataItemString(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::replicate(result));
}

#ifdef TEST

#include <xercesc/dom/DOMDocument.hpp>
#include "../testharness/TestFunction.hpp"

// Test functions

void FunctionString::setUp()
{

  // Nothing to do

}

FunctionString::FunctionString(std::string name)
  : XPathFunction(0, 1, vector<const DataItem*>())
{




}

// Not testes
void FunctionString::testExecute()
{

  // No testing, as this function is too simple.

}

#endif
