/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*

  Substring-after function

*/

#ifndef _FUNCTIONSUBSTRINGAFTER_HPP
#define _FUNCTIONSUBSTRINGAFTER_HPP


#include "XPathFunction.hpp"

/** Substring-after function. */
class PATHAN_EXPORT FunctionSubstringAfter : public XPathFunction
{
public:
  FunctionSubstringAfter(const vector<const DataItem*> &args);

  /** XPath function. returns the substring of the first string following the first occurrence of the second string within that string **/
  DataItem *execute(const Context *context) const;

#ifdef TEST
  ///Dummy constructor for test suite
  FunctionSubstringAfter(std::string name);
  ///Test setup
  void setUp();
  ///Test count
  void testExecute();
#endif
};

#endif // _FUNCTIONSUBSTRINGAFTER_HPP


#if 0
<userDoc>
<section>
  <title><command>substring-after</command></title>

  <section>
  <title>Synopsis</title>
  <para>
  <synopsis>
  <emphasis>substring-after(argument1,argument2) -> string</emphasis>
  argument1 = string  #PCDATA #REQUIRED
  argument2 = string #PCDATA #REQUIRED
  </synopsis>
  </para>
  </section>

  <section>
    <title>Description</title>
    <para>The substring-after function returns the substring of the first argument string that follows the first occurrence of the second argument string in the first argument string, or the empty string if the first argument string does not contain the second argument string.  For example substring-after("1999/04/01","/") returns 04/01, and substring-after("1999/04/01","19") returns 99/04/01.
    </para>
  </section>
</section>
</userDoc>

#endif

