/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*

  Substring-before function

*/

#ifndef _FUNCTIONSUBSTRINGBEFORE_HPP
#define _FUNCTIONSUBSTRINGBEFORE_HPP

#include <config.h>


#include "XPathFunction.hpp"

/** Substring-before function. */
class PATHAN_EXPORT FunctionSubstringBefore : public XPathFunction
{
public:
  FunctionSubstringBefore(const vector<const DataItem*> &args);

  /** XPath function. returns the substring of the first string preceding the first occurrence of the second string within that string **/
  DataItem *execute(const Context *context) const;

#ifdef TEST
  ///Dummy constructor for test suite
  FunctionSubstringBefore(std::string name);
  ///Test setup
  void setUp();
  ///Test count
  void testExecute();
#endif
};

#endif // _FUNCTIONSUBSTRINGBEFORE_HPP


#if 0
<userDoc>
<section>
  <title><command>substring-before</command></title>

  <section>
  <title>Synopsis</title>
  <para>
  <synopsis>
  <emphasis>substring-before(argument1,argument2) -> string</emphasis>
  argument1 = string  #PCDATA #REQUIRED
  argument2 = string #PCDATA #REQUIRED
  </synopsis>
  </para>
  </section>

  <section>
    <title>Description</title>
    <para>The substring-before function returns the substring of the first argument string that precedes the first occurrence of the second argument string in the first argument string, or the empty string if the first argument string does not contain the second argument string.  For example substring-before("1999/04/01","/") returns 1999.
    </para>
  </section>
</section>
</userDoc>

#endif






