/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*

  Translate function

*/

#ifndef _FUNCTIONTRANSLATE_HPP
#define _FUNCTIONTRANSLATE_HPP


#include "XPathFunction.hpp"

/** Translate function. */
class PATHAN_EXPORT FunctionTranslate : public XPathFunction
{
public:
  FunctionTranslate(const vector<const DataItem*> &args);

  /** XPath function. returns string1 with each character in string2 replaced with the corresponding character in string3 **/
  DataItem *execute(const Context *context) const;

#ifdef TEST
  ///Dummy constructor for test suite
  FunctionTranslate(std::string name);
  ///Test setup
  void setUp();
  ///Test count
  void testExecute();
#endif
};

#endif // _FUNCTIONTRANSLATE_HPP


#if 0
<userDoc>
<section>
  <title><command>translate</command></title>

  <section>
  <title>Synopsis</title>
  <para>
  <synopsis>
  <emphasis>translate(argument1,argument2,argument3) -> string</emphasis>
  argument1 = string #PCDATA #REQUIRED
  argument2 = string #PCDATA #REQUIRED
  argument3 = string #PCDATA #REQUIRED
  </synopsis>
  </para>
  </section>

  <section>
    <title>Description</title>
    <para>The translate function returns the first argument string with occurrences of
    characters in the second argument string replaced by the character at the correpsonding
    position in the third argument string.  For example, translate("bar","abc","ABC")
    returns the string BAr.  If there is a character in the second argument string with no
    character at a correpsinding position in the third argument string (because the second
    argument string is longer than the third argument string), then occurrences of that
    character in the first argument string are removed.  For example, translate("---aaa---",
    "abc-","ABC") returns"AAA".  If a chacracter occurs more than once in the second
    argument string, then the first occurrence determines the replacement character.  If
    the third argument string is longer than the second argument strin, then excess
    characters are ignored.</para>
    <para>NOTE: The translate function is not a sufficient solution for case conversion in
    all languages.  A futue version of XPath may provide additional functions for case
    conversion.
    </para>
  </section>
</section>
</userDoc>

#endif


