/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include "FunctionUnaryMinus.hpp"
#include "../dataItem/DataItemNumeric.hpp"

FunctionUnaryMinus::FunctionUnaryMinus(const vector<const DataItem*> &args)
  : XPathFunction(1, 1, args)
{
}

DataItem *FunctionUnaryMinus::execute(const Context *context) const
{
  return new DataItemNumeric(-getNumeralArg(0, context));
}

#ifdef TEST
// Test functions
#include "../dataItem/DataItemString.hpp"
#include "../dataItem/DataItemBool.hpp"
#include "../dataItem/DataItemNodeList.hpp"
#include "../testharness/TestFunction.hpp"

void FunctionUnaryMinus::setUp()
{

  // Nothing to do

}

FunctionUnaryMinus::FunctionUnaryMinus( std::string name)
   : XPathFunction(2, 2, vector<const DataItem*>())
{




}

void FunctionUnaryMinus::testExecute()
{



  Context c;
  Context *context = &c;

  auto_ptr<DataItemNumeric> num(new DataItemNumeric(2));
  DataItem *item1 = num.get();
  _args.push_back(item1);




  auto_ptr<DataItem> result(execute(context));

  assert(result->asNum(context) == -2);

  _args.clear();
}

#endif
