/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef _XPATHFUNCTION_HPP
#define _XPATHFUNCTION_HPP

#include "GeneralFunction.hpp"

/** Virtual interface class for functions */
class PATHAN_EXPORT XPathFunction : public GeneralFunction
{
public:
  /// constructor, checks for the correct number of arguments.
  XPathFunction(unsigned int argsFrom, unsigned int argsTo,
		const vector<const DataItem*> &args);

protected:
  /** returns argument argNum as a boolean */
  bool getBoolArg(unsigned int argNum, const Context *context) const;
  /** returns argument argNum as a string */
  const XMLCh *getStringArg(unsigned int argNum,
			 const Context *context) const;
  /** returns argument argNum as a numeral */
  XSFloat getNumeralArg(unsigned int argNum, const Context *context) const;
  /** returns argument argNum as a nodelist that the caller _must_ delete */
  DeadNodeList *getNodeListArg(unsigned int argNum,
                                     const Context *context) const;
  /** returns argument argNum as a data item */
  const DataItem *getDataItemArg(unsigned int argNum,
                                 const Context *context) const;
  /** returns argument argNum as an integer */
  int getIntArg(unsigned int argNum, const Context *context) const;
};

#endif // _XPATHFUNCTION_HPP
