/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef __XPATHEVALUATORIMPL_HPP
#define __XPATHEVALUATORIMPL_HPP

#include <config.h>

#include <dom3-xpath/ext/XPathEvaluatorExt.hpp>
#include "functionAPI/FunctionLookup.hpp"
#include "simpleVariables/VariableStore.hpp"

class PATHAN_EXPORT XPathEvaluatorImpl : public XPathEvaluatorExt
{
public:

  XPathEvaluatorImpl();
  ~XPathEvaluatorImpl();

  XPathExpression *createExpression(const XMLCh *expression, const XPathNSResolver *resolver)
    const throw (XPathException, XERCES_CPP_NAMESPACE_QUALIFIER DOMException);

  XPathNSResolver *createNSResolver(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *nodeResolver) const;

  XPathResult *evaluate(const XMLCh *expression, XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *contextNode,
                        const XPathNSResolver *resolver, const XPathResult::resultType type,
                        XPathResult *result) const throw (XPathException, XERCES_CPP_NAMESPACE_QUALIFIER DOMException);
  
  virtual void setGlobalVar(const XMLCh *name, const XMLCh *value);
  virtual void setGlobalVar(const XMLCh *name, bool value);
  virtual void setGlobalVar(const XMLCh *name, double value);
  virtual void setGlobalVar(const XMLCh *name, XERCES_CPP_NAMESPACE_QUALIFIER DOMNodeList *value);
  virtual void setGlobalVar(const XMLCh *name, XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument *value);

protected:

  //This context is shared between all created Expressions. We own it
  FunctionLookup *functionTable;
  VariableStore *variableStore;
}; //XPathEvaluatorImpl


#endif //__XPATHEVALUATORIMPL_HPP
