/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef __XPATHEXPRESSIONIMPL_HPP
#define __XPATHEXPRESSIONIMPL_HPP

#include <config.h>

#include <dom3-xpath/XPathExpression.hpp>
#include <dom3-xpath/XPathNSResolver.hpp>
#include "dataItem/DataItem.hpp"
#include "functionAPI/FunctionLookup.hpp"
#include "simpleVariables/VariableStore.hpp"

class XPathExpressionImpl : public XPathExpression
{
public:

  XPathExpressionImpl(DataItem *compiledExpression, const XPathNSResolver *nsResolver,
                      const FunctionLookup *funcTable, VariableStore *varStore);
  ~XPathExpressionImpl();

  XPathResult *evaluate(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *contextNode, const XPathResult::resultType type,
                        XPathResult *result) const throw (XPathException, XERCES_CPP_NAMESPACE_QUALIFIER DOMException);

protected:

  DataItem *compiledExpression;

  const XPathNSResolver *nsResolver;

  //Passed in from Evaluator
  const FunctionLookup *functionTable;
  VariableStore *variableStore;

}; //XPathExpressionImpl

#endif //__XPATHEXPRESSION_HPP

