/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef __XPATHNSRESOLVERIMPL_HPP
#define __XPATHNSRESOLVERIMPL_HPP

#include <config.h>

#include <xercesc/util/XMLString.hpp>
#include <dom3-xpath/XPathNSResolver.hpp>
#include "../DOMutils/v2NSUtils.hpp"

class XPathNSResolverImpl : public XPathNSResolver
{
public:

  XPathNSResolverImpl(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *resolverNode);
  ~XPathNSResolverImpl();

  const XMLCh *lookupNamespaceURI(const XMLCh *prefix) const;

  XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *getResolverNode() const;

protected:

  namespaceMapType *namespaceBindings;

  XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *resolverNode;
};//XPathNSResolverImpl


#endif //__XPATHNSRESOLVERIMPL_HPP
