/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include "AncestorAxis.hpp"

DeadNodeList *AncestorAxis::makeList(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, DeadNodeList *list) const
{
  list->clear();
  XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *parent = getParent(node);

  //Add all ancestors

  if(parent != 0) {
    while(parent->getNodeType() != XERCES_CPP_NAMESPACE_QUALIFIER DOMNode::DOCUMENT_NODE) {
      list->push_front(parent);
      parent = getParent(parent);
    }
  }

  return list;
}



