/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include "DescendantAxis.hpp"

DeadNodeList *DescendantAxis::makeList(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, DeadNodeList *list) const
{
  list->clear();
  makeListHelper(node, list);

  return list;
}//makeList


void DescendantAxis::makeListHelper(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, DeadNodeList *retList) const
{
  XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *child = node->getFirstChild();
  while (child!=NULL) {

    //recursively add descendants to the descendantList
    retList->push_back(child);

    if(child->getNodeType() == XERCES_CPP_NAMESPACE_QUALIFIER DOMNode::ELEMENT_NODE) { //is this check correct?
      makeListHelper(child, retList);
    }//of

    child = child->getNextSibling();
  }//while
}//makeListHelper

