/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include "DescendantOrSelfAxis.hpp"

DeadNodeList *DescendantOrSelfAxis::makeList(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, DeadNodeList *list) const
{
  list->clear();
  list->push_back(node);
  makeListHelper(node, list);

  return list;
}//makeList


void DescendantOrSelfAxis::makeListHelper(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, DeadNodeList *retList) const
{
  XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *child = node->getFirstChild();
  while (child!=NULL) {

    //recursively add descendants to the descendantList
    if(child->getNodeType() != XERCES_CPP_NAMESPACE_QUALIFIER DOMNode::ATTRIBUTE_NODE) {
      retList->push_back(child);
    }//if

    if(child->getNodeType() == XERCES_CPP_NAMESPACE_QUALIFIER DOMNode::ELEMENT_NODE) { //is this check correct?
      makeListHelper(child, retList);
    }//of

    child = child->getNextSibling();
  }//while
}//makeListHelper

