/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include "FollowingSiblingAxis.hpp"

DeadNodeList *FollowingSiblingAxis::makeList(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, DeadNodeList *list) const
{
  list->clear();
  //If the node is an attribute node, then return an empty list
  if(node->getNodeType() == XERCES_CPP_NAMESPACE_QUALIFIER DOMNode::ATTRIBUTE_NODE) {
    return list;
  }//if

  //Return all the siblings of the given node
  XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *currentNode = node->getNextSibling();
  while(currentNode!=NULL) {
    list->push_back(currentNode);
    currentNode = currentNode->getNextSibling();
  }//while

  return list;
}//makeList


