/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef _FORWARDAXIS_HPP
#define _FORWARDAXIS_HPP

#include <config.h>

#include "ForwardAxis.hpp"
#include "NavStep.hpp"

/**
This class specifies the forward axis. This axis direction is used by predicates.
*/


class PATHAN_EXPORT ForwardAxis : public NavStep
{
public:
  ForwardAxis();
  void doStep(DeadNodeList *candidateList, const Context *context, const bool creativeMode, const bool lastStep, DeadNodeList *result) const;

protected:
  virtual XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *doCreativeMode(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, const Context *context) const;
  virtual DeadNodeList *makeList(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, DeadNodeList *list) const = 0;
};


#endif

