/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include "ParentAxis.hpp"
#include <xercesc/dom/DOMAttr.hpp>

DeadNodeList *ParentAxis::makeList(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, DeadNodeList *list) const
{
  list->clear();
  XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *nodeParent = NULL;

  if(node->getNodeType() == XERCES_CPP_NAMESPACE_QUALIFIER DOMNode::ATTRIBUTE_NODE) {
    nodeParent = static_cast<XERCES_CPP_NAMESPACE_QUALIFIER DOMAttr *>(node)->getOwnerElement();
  } else {
    nodeParent = node->getParentNode();
  }

  //If there's a parent, then add it
  if(nodeParent!=NULL) {
    list->push_back(nodeParent);
  }//if

  return list;
}//makeList
