/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef _REVERSEAXIS_HPP
#define _REVERSEAXIS_HPP

#include <config.h>


#include "NavStep.hpp"

/**
This class is a base class for all reverse axis. In order for numeric predicates to work correctly
the nodes retuned from makeList have to be in docuemnt order.
*/


class PATHAN_EXPORT ReverseAxis : public NavStep
{
protected:

public:
  ReverseAxis();

  XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *getParent(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node) const;

  void doStep(DeadNodeList *candidateList, const Context *context, const bool creativeMode, const bool lastStep, DeadNodeList *result) const;

protected:

  virtual XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *doCreativeMode(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, const Context *context) const;
  virtual DeadNodeList *makeList(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, DeadNodeList *list) const = 0;


};


#endif

