/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*

  Scope

*/

#ifndef _SCOPE_HPP
#define _SCOPE_HPP

#include <config.h>

#ifdef WIN32
#pragma warning( disable: 4786 )
#endif

#include "../DOMutils/XMLChStringHash.hpp"
#include "VarHashEntry.hpp"

/** used inside VariableStore to implement variable scoping */
class Scope
{
public:

  /** enum for classifying type of scope */
  typedef enum {
    GLOBAL = 0,
    LOCAL = 1,
    LOGICAL_BLOCK = 2
  } Type;

  typedef XMLChStringHash VarHash;

  /** constructor. */
  Scope(Type type);

  Type getType() const;
  VarHash &getMap();
  const VarHash &getMap() const;

private:
  Type _type;
  XMLChStringHash _map;

  Scope(const Scope &rhs);
  Scope &operator=(const Scope &rhs);
};

#endif // _SCOPE_HPP
