/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include "VarHashEntry.hpp"
#include "../dataItem/DataItemNodeList.hpp"

VarHashEntry::VarHashEntry(DataItem *value)
  : _value(value)
{
  // Nothing to do
}

VarHashEntry::VarHashEntry()
  : _value(new DataItemNodeList(new DeadNodeList()))
{
  // Nothing to do
}

VarHashEntry::~VarHashEntry()
{
  delete _value, _value=NULL;
  // Nothing to do
}

const DataItem *VarHashEntry::getValue() const
{
  return _value;
}

void VarHashEntry::setValue(DataItem *value)
{
  delete _value;
  _value = value;
}
