/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef _VARHASHENTRY_HPP
#define _VARHASHENTRY_HPP

#include <config.h>

#include "../dataItem/DataItem.hpp"

/** The class that stores the values of the variables. */
class VarHashEntry
{
public:
  /// default constructor, for DOMStringHash
  VarHashEntry();
  /// Meaningfull constructor
  VarHashEntry(DataItem *value);
  /// virtual destructor (does nothing)
  virtual ~VarHashEntry();

  /** Gets the value of the variable (overload in derived classes for
      special behaviour) */
  virtual const DataItem *getValue() const;

  /** Sets the value of the variable (overload in derived classes for
      special behaviour) */
  virtual void setValue(DataItem *value);

protected:

  DataItem *_value;

private:

  VarHashEntry(const VarHashEntry &rhs);
  VarHashEntry &operator=(const VarHashEntry &rhs);
};

#endif
