/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include "TestDatatypes.h"
#include "../dataItem/DataItemBool.hpp"
#include "../dataItem/DataItemString.hpp"
#include "../dataItem/DataItemNumeric.hpp"
#include "../dataItem/DataItemNodeList.hpp"

TestDatatypes::TestDatatypes(string name)
  : TestCase(name)
{
  // Nothing to do
}

TestDatatypes::~TestDatatypes()
{
  //Nothing to do
}


void TestDatatypes::setUp()
{
  // Nothing to do
}

Test* TestDatatypes::suite()
{
  TestSuite* testSuite = new TestSuite("DataTypes");


  testSuite->addTest( new TestCaller<DataItemBool> ("testAsBool",
						      &DataItemBool::testAsBool));
  testSuite->addTest( new TestCaller<DataItemBool> ("testAsString",
						      &DataItemBool::testAsString));
  testSuite->addTest( new TestCaller<DataItemBool> ("testAsNum",
						      &DataItemBool::testAsNum));
  testSuite->addTest( new TestCaller<DataItemBool> ("testAsNodeList",
						      &DataItemBool::testAsNodeList));
  testSuite->addTest( new TestCaller<DataItemBool> ("testEqual",
						      &DataItemBool::testEquals));
  testSuite->addTest( new TestCaller<DataItemBool> ("testLessThan",
						      &DataItemBool::testLessThan));
  testSuite->addTest( new TestCaller<DataItemBool> ("testGreaterThan",
						      &DataItemBool::testGreaterThan));

  testSuite->addTest( new TestCaller<DataItemNodeList> ("testAsBool",
						      &DataItemNodeList::testAsBool));
  testSuite->addTest( new TestCaller<DataItemNodeList> ("testAsString",
						      &DataItemNodeList::testAsString));
  testSuite->addTest( new TestCaller<DataItemNodeList> ("testAsNum",
						      &DataItemNodeList::testAsNum));
  testSuite->addTest( new TestCaller<DataItemNodeList> ("testAsNodeList",
						      &DataItemNodeList::testAsNodeList));
  testSuite->addTest( new TestCaller<DataItemNodeList> ("testAsInt",
						      &DataItemNodeList::testAsInt));
  testSuite->addTest( new TestCaller<DataItemNodeList> ("testEquals",
						      &DataItemNodeList::testEquals));
  testSuite->addTest( new TestCaller<DataItemNodeList> ("testLessThan",
						      &DataItemNodeList::testLessThan));
  testSuite->addTest( new TestCaller<DataItemNodeList> ("testGreaterThan",
						      &DataItemNodeList::testGreaterThan));
  

  testSuite->addTest( new TestCaller<DataItemNumeric> ("testAsBool",
						       &DataItemNumeric::testAsBool));
  testSuite->addTest( new TestCaller<DataItemNumeric> ("testAsString",
						       &DataItemNumeric::testAsString));
  testSuite->addTest( new TestCaller<DataItemNumeric> ("testAsNum",
						       &DataItemNumeric::testAsNum));
  testSuite->addTest( new TestCaller<DataItemNumeric> ("testAsNodeList",
						       &DataItemNumeric::testAsNodeList));
  testSuite->addTest( new TestCaller<DataItemNumeric> ("testEquals",         
						       &DataItemNumeric::testEquals));
  testSuite->addTest( new TestCaller<DataItemNumeric> ("testLessThan",
						       &DataItemNumeric::testLessThan)) ;
  testSuite->addTest( new TestCaller<DataItemNumeric> ("testGreaterThan",
						       &DataItemNumeric::testGreaterThan));

  testSuite->addTest( new TestCaller<DataItemString> ("testAsBool",
						      &DataItemString::testAsBool));
  testSuite->addTest( new TestCaller<DataItemString> ("testAsString",
						      &DataItemString::testAsString));
  testSuite->addTest( new TestCaller<DataItemString> ("testAsNum",
						      &DataItemString::testAsNum));
  testSuite->addTest( new TestCaller<DataItemString> ("testAsNodeList",
						      &DataItemString::testAsNodeList));
  testSuite->addTest( new TestCaller<DataItemString> ("testEqual",
						      &DataItemString::testEquals));
  testSuite->addTest( new TestCaller<DataItemString> ("testLessThan",
						      &DataItemString::testLessThan));
  testSuite->addTest( new TestCaller<DataItemString> ("testGreaterThan",
						      &DataItemString::testGreaterThan));

  return testSuite;
}





















