/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*
  Useful tester functions
*/

#ifndef _TESTFUNCTION_HPP
#define _TESTFUNCTION_HPP

#include <config.h>

#include <assert.h>
#include <string>

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/parsers/XercesDOMParser.hpp>
#include <xercesc/dom/DOM.hpp>

#include "../exceptions/DSLException.hpp"
#include "../lexer/LexerDOMStringStream.hpp"

#include "../functionAPI/FunctionLookup.hpp"

#include "../dataItem/DataItemNav.hpp"

extern int DSLPathyyparse(void *);
extern int DSLPathyydebug;

/** class of useful tester functions */
class TestFunction
{
public:
  /// constructor
  TestFunction();
  /// destructor
  ~TestFunction();
  
  /// Initialise the DOM environment.
  void initDOM();
  /// Initialise a DOM parser.
  void initDOMParser(XERCES_CPP_NAMESPACE_QUALIFIER XercesDOMParser &xmlparser);
  XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument *parseXML(XERCES_CPP_NAMESPACE_QUALIFIER XercesDOMParser &xmlparser, char *file);
  FunctionLookup *initFunctionLookup();
  XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument *initScriptTree();
  XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument *initDataTree();
  XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument *initOutputTree();
};

#endif // _TESTFUNCTION_HPP








