# Header manipulation script for UNIX

# Integrate configure produced config.h into Pathan.hpp. Pathan is a
# library and may be used within a project which itself defines
# config.h, leading to problems

# Firstly manipulation config.h

open CONFIGH, $ARGV[0];
open CONFIGHNEXT, ">objs/config.h";

# read and ignore config.h up to and including `BEGIN CONFIG.H' line

while(defined($_ = <CONFIGH>) and !(/BEGIN CONFIG\.H/)) {
}

# read and output config.h up to (but not including) `END CONFIG.H'

while(defined($_ = <CONFIGH>) and !(/END CONFIG\.H/)) {
    print CONFIGHNEXT $_;
}

close CONFIGHNEXT;

open PATHAN, "src/dom3-xpath/Pathan.hpp";
open PATHANEXT, ">objs/Pathan.hpp";
open CONFIGHNEXT, "objs/config.h";

# Read and output Pathan.hpp up until #include <config.h>

while(defined($_ = <PATHAN>) and !(/\#include <config.h>/)) {
    print PATHANEXT $_;
}

# Write contents of the processed config.h

while(defined($_ = <CONFIGHNEXT>)) {
    print PATHANEXT $_;
}

# Write remainder of Pathan.hpp

while(defined($_ = <PATHAN>)) {
    print PATHANEXT $_;
}

close CONFIGHNEXT;
close PATHAN;
close PATHANEXT;

# delete temporary config.h

unlink("objs/config.h");
